/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania F - Kostka Rubika
 *
 * Autor programu: Piotr Gawron
 */

#include<stdio.h>
#include<assert.h>
#include<stdlib.h>
/*
    Uwaga tester traktuje wszystkie PE na rowni z WA
*/
char* sysout_low = "-ulfrbd";
char* sysout_up = "-ULFRBD";

class m_kostka
{
public:
    int p_l;	//lewa strona
    int p_r;	//prawa
    int p_u;	//gora
    int p_d;	//dol
    int p_f;	//przod
    int p_b;	//tyl
    //duza litera zgodnie ze wskazowkami zegara
    //mala przeciw
    void L()	//f->d->b->t->f
    {
	int x=p_f;
	p_f=p_u;
	p_u=p_b;
	p_b=p_d;
	p_d=x;
    }
    void l() //f->t->b->d->f
    {
	int x=p_f;
	p_f=p_d;
	p_d=p_b;
	p_b=p_u;
	p_u=x;
    }
    void r()	//f->d->b->t->f
    {
	int x=p_f;
	p_f=p_u;
	p_u=p_b;
	p_b=p_d;
	p_d=x;
    }
    void R() //f->t->b->d->f
    {
	int x=p_f;
	p_f=p_d;
	p_d=p_b;
	p_b=p_u;
	p_u=x;
    }
    void F()
    {
	int x=p_r;
	p_r=p_u;
	p_u=p_l;
	p_l=p_d;
	p_d=x;
    }
    void f()
    {
	int x=p_d;
	p_d=p_l;
	p_l=p_u;
	p_u=p_r;
	p_r=x;
    }
    void b()
    {
	int x=p_r;
	p_r=p_u;
	p_u=p_l;
	p_l=p_d;
	p_d=x;
    }
    void B()
    {
	int x=p_d;
	p_d=p_l;
	p_l=p_u;
	p_u=p_r;
	p_r=x;
    }
    void U()
    {
	int x=p_l;
	p_l=p_f;
	p_f=p_r;
	p_r=p_b;
	p_b=x;
    }
    void u()
    {
	int x=p_b;
	p_b=p_r;
	p_r=p_f;
	p_f=p_l;
	p_l=x;
    }
    void d()
    {
	int x=p_l;
	p_l=p_f;
	p_f=p_r;
	p_r=p_b;
	p_b=x;
    }
    void D()
    {
	int x=p_b;
	p_b=p_r;
	p_r=p_f;
	p_f=p_l;
	p_l=x;
    }
    void show()
    {
	printf(" %d \n",p_b);
	printf("%d%d%d\n",p_l,p_u,p_r);
	printf(" %d \n",p_f);
	printf(" %d \n",p_d);
    }
};
class d_kostka
{
public:
    m_kostka kostka[3][3][3];
    m_kostka obrot;
    void L();	//f->d->b->t->f
    void l(); 	//f->t->b->d->f
    void r();	//f->d->b->t->f
    void R(); //f->t->b->d->f
    void F();
    void f();
    void b();
    void B();
    void U();
    void u();
    void d();
    void D();
    
    void all_L();	//f->d->b->t->f
    void all_l(); 	//f->t->b->d->f
    void all_r();	//f->d->b->t->f
    void all_R(); //f->t->b->d->f
    void all_F();
    void all_f();
    void all_b();
    void all_B();
    void all_U();
    void all_u();
    void all_d();
    void all_D();
    
    void show();
    void read(FILE *fin);
    void solve();
    bool correct();
    bool consist(int x,int y, int z, int kol);
    void three_corners();
    void rotate_corners();
    void left_right();
    void edges();
    void flip_edges();
    void move_down_corner_up_corner(int x, int y, int x1, int y1);
};
void d_kostka::L()	//f->d->b->t->f
{
    printf("%c",sysout_up[obrot.p_l]);
    m_kostka tmp;
    int x,y,z;
    x=0;
    for (y=0;y<3;y++)
	for (z=0;z<3;z++)
	    kostka[x][y][z].L();
    tmp=kostka[x][0][0];
    kostka[x][0][0]=kostka[x][2][0];
    kostka[x][2][0]=kostka[x][2][2];
    kostka[x][2][2]=kostka[x][0][2];
    kostka[x][0][2]=tmp;
    
    tmp=kostka[x][1][0];
    kostka[x][1][0]=kostka[x][2][1];
    kostka[x][2][1]=kostka[x][1][2];
    kostka[x][1][2]=kostka[x][0][1];
    kostka[x][0][1]=tmp;
    
}
void d_kostka::l() //f->t->b->d->f
{
    printf("%c",sysout_low[obrot.p_l]);
    m_kostka tmp;
    int x,y,z;
    x=0;
    for (y=0;y<3;y++)
	for (z=0;z<3;z++)
	    kostka[x][y][z].l();
    tmp=kostka[x][0][0];
    kostka[x][0][0]=kostka[x][0][2];
    kostka[x][0][2]=kostka[x][2][2];
    kostka[x][2][2]=kostka[x][2][0];
    kostka[x][2][0]=tmp;
    
    tmp=kostka[x][1][0];
    kostka[x][1][0]=kostka[x][0][1];
    kostka[x][0][1]=kostka[x][1][2];
    kostka[x][1][2]=kostka[x][2][1];
    kostka[x][2][1]=tmp;
}
void d_kostka::r()	//f->d->b->t->f
{
    printf("%c",sysout_low[obrot.p_r]);
    m_kostka tmp;
    int x,y,z;
    x=2;
    for (y=0;y<3;y++)
	for (z=0;z<3;z++)
	    kostka[x][y][z].r();
    tmp=kostka[x][0][0];
    kostka[x][0][0]=kostka[x][2][0];
    kostka[x][2][0]=kostka[x][2][2];
    kostka[x][2][2]=kostka[x][0][2];
    kostka[x][0][2]=tmp;
    
    tmp=kostka[x][1][0];
    kostka[x][1][0]=kostka[x][2][1];
    kostka[x][2][1]=kostka[x][1][2];
    kostka[x][1][2]=kostka[x][0][1];
    kostka[x][0][1]=tmp;
}
void d_kostka::R() //f->t->b->d->f
{
    printf("%c",sysout_up[obrot.p_r]);
    m_kostka tmp;
    int x,y,z;
    x=2;
    for (y=0;y<3;y++)
	for (z=0;z<3;z++)
	    kostka[x][y][z].R();
    tmp=kostka[x][0][0];
    kostka[x][0][0]=kostka[x][0][2];
    kostka[x][0][2]=kostka[x][2][2];
    kostka[x][2][2]=kostka[x][2][0];
    kostka[x][2][0]=tmp;
    
    tmp=kostka[x][1][0];
    kostka[x][1][0]=kostka[x][0][1];
    kostka[x][0][1]=kostka[x][1][2];
    kostka[x][1][2]=kostka[x][2][1];
    kostka[x][2][1]=tmp;
}
void d_kostka::F()
{
    printf("%c",sysout_up[obrot.p_f]);
    m_kostka tmp;
    int x,y,z;
    z=0;
    for (y=0;y<3;y++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].F();
    tmp=kostka[0][0][z];
    kostka[0][0][z]=kostka[2][0][z];
    kostka[2][0][z]=kostka[2][2][z];
    kostka[2][2][z]=kostka[0][2][z];
    kostka[0][2][z]=tmp;
    
    tmp=kostka[0][1][z];
    kostka[0][1][z]=kostka[1][0][z];
    kostka[1][0][z]=kostka[2][1][z];
    kostka[2][1][z]=kostka[1][2][z];
    kostka[1][2][z]=tmp;
}
void d_kostka::f()
{
    printf("%c",sysout_low[obrot.p_f]);
    m_kostka tmp;
    int x,y,z;
    z=0;
    for (y=0;y<3;y++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].f();
    tmp=kostka[0][0][z];
    kostka[0][0][z]=kostka[0][2][z];
    kostka[0][2][z]=kostka[2][2][z];
    kostka[2][2][z]=kostka[2][0][z];
    kostka[2][0][z]=tmp;
    
    tmp=kostka[0][1][z];
    kostka[0][1][z]=kostka[1][2][z];
    kostka[1][2][z]=kostka[2][1][z];
    kostka[2][1][z]=kostka[1][0][z];
    kostka[1][0][z]=tmp;
}
void d_kostka::b()
{
    printf("%c",sysout_low[obrot.p_b]);
    m_kostka tmp;
    int x,y,z;
    z=2;
    for (y=0;y<3;y++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].b();
    tmp=kostka[0][0][z];
    kostka[0][0][z]=kostka[2][0][z];
    kostka[2][0][z]=kostka[2][2][z];
    kostka[2][2][z]=kostka[0][2][z];
    kostka[0][2][z]=tmp;
    
    tmp=kostka[0][1][z];
    kostka[0][1][z]=kostka[1][0][z];
    kostka[1][0][z]=kostka[2][1][z];
    kostka[2][1][z]=kostka[1][2][z];
    kostka[1][2][z]=tmp;
}
void d_kostka::B()
{
    printf("%c",sysout_up[obrot.p_b]);
    m_kostka tmp;
    int x,y,z;
    z=2;
    for (y=0;y<3;y++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].B();
    tmp=kostka[0][0][z];
    kostka[0][0][z]=kostka[0][2][z];
    kostka[0][2][z]=kostka[2][2][z];
    kostka[2][2][z]=kostka[2][0][z];
    kostka[2][0][z]=tmp;
    
    tmp=kostka[0][1][z];
    kostka[0][1][z]=kostka[1][2][z];
    kostka[1][2][z]=kostka[2][1][z];
    kostka[2][1][z]=kostka[1][0][z];
    kostka[1][0][z]=tmp;
}
void d_kostka::U()
{
    printf("%c",sysout_up[obrot.p_u]);
    m_kostka tmp;
    int x,y,z;
    y=2;
    for (z=0;z<3;z++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].U();
    tmp=kostka[0][y][0];
    kostka[0][y][0]=kostka[2][y][0];
    kostka[2][y][0]=kostka[2][y][2];
    kostka[2][y][2]=kostka[0][y][2];
    kostka[0][y][2]=tmp;
    
    tmp=kostka[0][y][1];
    kostka[0][y][1]=kostka[1][y][0];
    kostka[1][y][0]=kostka[2][y][1];
    kostka[2][y][1]=kostka[1][y][2];
    kostka[1][y][2]=tmp;
}
void d_kostka::u()
{
    printf("%c",sysout_low[obrot.p_u]);
    m_kostka tmp;
    int x,y,z;
    y=2;
    for (z=0;z<3;z++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].u();
    tmp=kostka[0][y][0];
    kostka[0][y][0]=kostka[0][y][2];
    kostka[0][y][2]=kostka[2][y][2];
    kostka[2][y][2]=kostka[2][y][0];
    kostka[2][y][0]=tmp;
    
    tmp=kostka[0][y][1];
    kostka[0][y][1]=kostka[1][y][2];
    kostka[1][y][2]=kostka[2][y][1];
    kostka[2][y][1]=kostka[1][y][0];
    kostka[1][y][0]=tmp;
}
void d_kostka::d()
{
    printf("%c",sysout_low[obrot.p_d]);
    m_kostka tmp;
    int x,y,z;
    y=0;
    for (z=0;z<3;z++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].d();
    tmp=kostka[0][y][0];
    kostka[0][y][0]=kostka[2][y][0];
    kostka[2][y][0]=kostka[2][y][2];
    kostka[2][y][2]=kostka[0][y][2];
    kostka[0][y][2]=tmp;
    
    tmp=kostka[0][y][1];
    kostka[0][y][1]=kostka[1][y][0];
    kostka[1][y][0]=kostka[2][y][1];
    kostka[2][y][1]=kostka[1][y][2];
    kostka[1][y][2]=tmp;
}
void d_kostka::D()
{
    printf("%c",sysout_up[obrot.p_d]);
    m_kostka tmp;
    int x,y,z;
    y=0;
    for (z=0;z<3;z++)
	for (x=0;x<3;x++)
	    kostka[x][y][z].D();
    tmp=kostka[0][y][0];
    kostka[0][y][0]=kostka[0][y][2];
    kostka[0][y][2]=kostka[2][y][2];
    kostka[2][y][2]=kostka[2][y][0];
    kostka[2][y][0]=tmp;
    
    tmp=kostka[0][y][1];
    kostka[0][y][1]=kostka[1][y][2];
    kostka[1][y][2]=kostka[2][y][1];
    kostka[2][y][1]=kostka[1][y][0];
    kostka[1][y][0]=tmp;
}

void d_kostka::read(FILE *fin)
{
    int i,j,x,y,z;
    char in[20][20];
    for (j=0;j<9;j++){
	fgets(in[j],15,fin);
    }	
    obrot.p_u=1;
    obrot.p_d=6;
    obrot.p_f=3;
    obrot.p_b=5;
    obrot.p_l=2;
    obrot.p_r=4;
//gorna scianka
    y=2;
    for (z=2,i=0;z>=0;z--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    kostka[x][y][z].p_u=in[i][j]-'0';
//dolna scianka
    y=0;
    for (z=0,i=6;z<3;z++,i++)
	for (x=0,j=3;x<3;x++,j++)
	    kostka[x][y][z].p_d=in[i][j]-'0';
//lewa scianka
    x=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=2,j=0;z>=0;z--,j++)
	    kostka[x][y][z].p_l=in[i][j]-'0';
//prawa scianka
    x=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=0,j=6;z<3;z++,j++)
	    kostka[x][y][z].p_r=in[i][j]-'0';
//przednia scianka
    z=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    kostka[x][y][z].p_f=in[i][j]-'0';
//przednia tylna
    z=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=2,j=9;x>=0;x--,j++)
	    kostka[x][y][z].p_b=in[i][j]-'0';
    for (i=0;i<3;i++)
	for (j=0;j<3;j++)
	    assert(in[i][j]==' ');
    for (i=0;i<3;i++)
	for (j=6;j<12;j++)
	    assert(in[i][j]==' ');
	    
    for (i=6;i<9;i++)
	for (j=0;j<3;j++)
	    assert(in[i][j]==' ');
    for (i=6;i<9;i++)
	for (j=6;j<12;j++)
	    assert(in[i][j]==' ');
	    
    for (i=0;i<3;i++)
	for (j=3;j<6;j++)
	    assert(in[i][j]>='1'&&in[i][j]<='6');
    for (i=3;i<6;i++)
	for (j=0;j<12;j++)
	    assert(in[i][j]>='1'&&in[i][j]<='6');
    for (i=6;i<9;i++)
	for (j=3;j<6;j++)
	    assert(in[i][j]>='1'&&in[i][j]<='6');
}

void d_kostka::show()
{
    printf("\n");
    int i,j,x,y,z;
    char out[20][20];
    for (j=0;j<9;j++)
    {
	for (i=0;i<12;i++)
	    out[j][i]=' ';
	out[j][12]=0;
    }
	
//gorna scianka
    y=2;
    for (z=2,i=0;z>=0;z--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    out[i][j]=kostka[x][y][z].p_u+'0';
//dolna scianka
    y=0;
    for (z=0,i=6;z<3;z++,i++)
	for (x=0,j=3;x<3;x++,j++)
	    out[i][j]=kostka[x][y][z].p_d+'0';
//lewa scianka
    x=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=2,j=0;z>=0;z--,j++)
	    out[i][j]=kostka[x][y][z].p_l+'0';
//prawa scianka
    x=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=0,j=6;z<3;z++,j++)
	    out[i][j]=kostka[x][y][z].p_r+'0';
//przednia scianka
    z=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    out[i][j]=kostka[x][y][z].p_f+'0';
//przednia tylna
    z=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=2,j=9;x>=0;x--,j++)
	    out[i][j]=kostka[x][y][z].p_b+'0';
	    
    for (i=0;i<9;i++)
	printf("%s\n",out[i]);
    
/*
    printf("   %d%d%d   \n",kostka[0][0][2].p_b,kostka[1][0][2].p_b,kostka[2][0][2].p_b);
    printf("   %d%d%d   \n",kostka[0][1][2].p_b,kostka[1][1][2].p_b,kostka[2][1][2].p_b);
    printf("   %d%d%d   \n",kostka[0][2][2].p_b,kostka[1][2][2].p_b,kostka[2][2][2].p_b);
    printf("%d%d%d%d%d%d%d%d%d\n",kostka[0][0][2].p_l,kostka[0][1][2].p_l,kostka[0][2][2].p_l,kostka[0][2][2].p_u,kostka[1][2][2].p_u,kostka[2][2][2].p_u,kostka[2][2][2].p_r,kostka[2][1][2].p_r,kostka[2][0][2].p_r);
    printf("%d%d%d%d%d%d%d%d%d\n",kostka[0][0][1].p_l,kostka[0][1][1].p_l,kostka[0][2][1].p_l,kostka[0][2][1].p_u,kostka[1][2][1].p_u,kostka[2][2][1].p_u,kostka[2][2][1].p_r,kostka[2][1][1].p_r,kostka[2][0][1].p_r);
    printf("%d%d%d%d%d%d%d%d%d\n",kostka[0][0][0].p_l,kostka[0][1][0].p_l,kostka[0][2][0].p_l,kostka[0][2][0].p_u,kostka[1][2][0].p_u,kostka[2][2][0].p_u,kostka[2][2][0].p_r,kostka[2][1][0].p_r,kostka[2][0][0].p_r);
    printf("   %d%d%d   \n",kostka[0][2][0].p_f,kostka[1][2][0].p_f,kostka[2][2][0].p_f);
    printf("   %d%d%d   \n",kostka[0][1][0].p_f,kostka[1][1][0].p_f,kostka[2][1][0].p_f);
    printf("   %d%d%d   \n",kostka[0][0][0].p_f,kostka[1][0][0].p_f,kostka[2][0][0].p_f);
    printf("   %d%d%d   \n",kostka[0][0][0].p_d,kostka[1][0][0].p_d,kostka[2][0][0].p_d);
    printf("   %d%d%d   \n",kostka[0][0][1].p_d,kostka[1][0][1].p_d,kostka[2][0][1].p_d);
    printf("   %d%d%d   \n",kostka[0][0][2].p_d,kostka[1][0][2].p_d,kostka[2][0][2].p_d);*/
}
bool d_kostka::correct()
{
    int x,y,z,i,j;
//gorna scianka
    y=2;
    for (z=2,i=0;z>=0;z--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    if (kostka[x][y][z].p_u!=1)
		return false;
//dolna scianka
    y=0;
    for (z=0,i=6;z<3;z++,i++)
	for (x=0,j=3;x<3;x++,j++)
	    if (kostka[x][y][z].p_d!=6)
		return false;
//lewa scianka
    x=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=2,j=0;z>=0;z--,j++)
	    if (kostka[x][y][z].p_l!=2)
		return false;
//prawa scianka
    x=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (z=0,j=6;z<3;z++,j++)
	    if (kostka[x][y][z].p_r!=4)
		return false;
//przednia scianka
    z=0;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=0,j=3;x<3;x++,j++)
	    if (kostka[x][y][z].p_f!=3)
		return false;
//przednia tylna
    z=2;
    for (y=2,i=3;y>=0;y--,i++)
	for (x=2,j=9;x>=0;x--,j++)
	    if (kostka[x][y][z].p_b!=5)
		return false;
    return true;
}
void d_kostka::all_L()
{
    int i,j,k;
    for (i=0;i<3;i++)
	for (j=0;j<3;j++)
	    for (k=0;k<3;k++)
		kostka[i][j][k].L();
    for (int x=0;x<3;x++)
    {
	m_kostka tmp=kostka[x][0][0];
	kostka[x][0][0]=kostka[x][2][0];
        kostka[x][2][0]=kostka[x][2][2];
        kostka[x][2][2]=kostka[x][0][2];
        kostka[x][0][2]=tmp;
    
        tmp=kostka[x][1][0];
        kostka[x][1][0]=kostka[x][2][1];
        kostka[x][2][1]=kostka[x][1][2];
        kostka[x][1][2]=kostka[x][0][1];
        kostka[x][0][1]=tmp;
    }
    obrot.L();
}
void d_kostka::all_l()
{
    all_L();
    all_L();
    all_L();
}
void d_kostka::all_r()
{
    all_R();
    all_R();
    all_R();
}
void d_kostka::all_R()
{
    all_l();
}
void d_kostka::all_F()
{
    int i,j,k;
    for (i=0;i<3;i++)
	for (j=0;j<3;j++)
	    for (k=0;k<3;k++)
		kostka[i][j][k].F();
    for(int z=0;z<3;z++)
    {
	m_kostka tmp=kostka[0][0][z];
        kostka[0][0][z]=kostka[2][0][z];
        kostka[2][0][z]=kostka[2][2][z];
        kostka[2][2][z]=kostka[0][2][z];
        kostka[0][2][z]=tmp;
        
        tmp=kostka[0][1][z];
        kostka[0][1][z]=kostka[1][0][z];
        kostka[1][0][z]=kostka[2][1][z];
        kostka[2][1][z]=kostka[1][2][z];
        kostka[1][2][z]=tmp;
    }
    obrot.F();
}
void d_kostka::all_f()
{
    all_F();
    all_F();
    all_F();
}    
void d_kostka::all_b()
{
    all_B();
    all_B();
    all_B();
}
void d_kostka::all_B()
{
    all_f();
}
void d_kostka::all_U()
{
    int i,j,k;
    for (i=0;i<3;i++)
	for (j=0;j<3;j++)
	    for (k=0;k<3;k++)
		kostka[i][j][k].U();
    for(int y=0;y<3;y++)
    {
        m_kostka tmp=kostka[0][y][0];
        kostka[0][y][0]=kostka[2][y][0];
        kostka[2][y][0]=kostka[2][y][2];
        kostka[2][y][2]=kostka[0][y][2];
        kostka[0][y][2]=tmp;
        
        tmp=kostka[0][y][1];
        kostka[0][y][1]=kostka[1][y][0];
        kostka[1][y][0]=kostka[2][y][1];
        kostka[2][y][1]=kostka[1][y][2];
        kostka[1][y][2]=tmp;
    }
    obrot.U();
}
void d_kostka::all_u()
{
    all_U();
    all_U();
    all_U();
}
void d_kostka::all_d()
{	
    all_D();
    all_D();
    all_D();
}
void d_kostka::all_D()
{
    all_u();
}

/*
    przerzucamy jeden naroznik z dolu do gory 
    modyfikujemy rozlozenie naroznikow (ale te co byly u gory zostaja u gory)
*/
void d_kostka::move_down_corner_up_corner(int x, int y, int x1, int y1)
{
    if (x1+y1==4)
    {
	u();
	u();
    }
    else if(x1==2)
	U();
    else if(y1==2)
	u();
	
    if (x+y==4)
    {
	d();
	d();
    }
    else if(x==2)
	d();
    else if(y==2)
	D();
	
    all_U();
    all_F();
    three_corners();
    all_f();
    all_u();
}

/*  
    obracamy 3 naroznki UFL -> UBL -> UBR
*/
void d_kostka::three_corners()
{
    r();
    b();
    l();
    f();
}
void d_kostka::rotate_corners()
{
    U();
    U();
    R();
    U();
    r();
    U();
    R();
    U();
    U();
    r();
}
void d_kostka::left_right()
{
    L();
    D();
    l();
    D();
    L();
    D();
    D();
    l();
    r();
    d();
    R();
    d();
    r();
    D();
    D();
    R();
}
void d_kostka::edges()
{
    all_f();
    U();
    U();
    F();
    U();
    U();
    L();
    r();
    F();
    F();
    l();
    R();
    f();
    U();
    U();
    all_F();
}
void d_kostka::flip_edges() //obraca tylna gorna krawedz
{
    all_r();
    F();
    U();
    d();
    L();
    L();
    U();
    U();
    D();
    D();
    R();
    U();
    r();
    D();
    D();
    U();
    U();
    L();
    L();
    D();
    u();
    f();
    u();
    all_R();
}
bool d_kostka::consist(int x, int y, int z, int kol)
{
    if (kostka[x][y][z].p_l==kol)
	return true;
    if (kostka[x][y][z].p_r==kol)
	return true;
    if (kostka[x][y][z].p_u==kol)
	return true;
    if (kostka[x][y][z].p_d==kol)
	return true;
    if (kostka[x][y][z].p_f==kol)
	return true;
    if (kostka[x][y][z].p_b==kol)
	return true;
    return false;
}
void d_kostka::solve()
{
    int x,y,x1,y1;
    int i;
//ustawmy gorne narozniki na gorze, a dolne na dole
    for (i=0;i<4;i++)
    {
	x=-1;
	y=-1;
	x1=-1;
	y1=-1;
	if (consist(0,0,0,kostka[1][2][1].p_u))
	    x=0,y=0;
	else
	if (consist(2,0,0,kostka[1][2][1].p_u))
	    x=2,y=0;
	else
	if (consist(0,0,2,kostka[1][2][1].p_u))
	    x=0,y=2;
	else
	if (consist(2,0,2,kostka[1][2][1].p_u))
	    x=2,y=2;
	
	if (!consist(0,2,0,kostka[1][2][1].p_u))
	    x1=0,y1=0;
	else
	if (!consist(0,2,2,kostka[1][2][1].p_u))
	    x1=0,y1=2;
	else
	if (!consist(2,2,0,kostka[1][2][1].p_u))
	    x1=2,y1=0;
	else
	if (!consist(2,2,2,kostka[1][2][1].p_u))
	    x1=2,y1=2;
	if (x>=0)
	{
	    move_down_corner_up_corner(x,y,x1,y1);
	}
    }
//wlasciwe narozniki we wlasciwych naroznikach (gora)
    while (!(consist(2,2,0,kostka[1][1][0].p_f)&&consist(2,2,0,kostka[2][1][1].p_r)))
	U();
    while (!(consist(0,2,0,kostka[0][1][1].p_l)&&consist(0,2,0,kostka[1][1][0].p_f)))
	three_corners();
    if (!(consist(0,2,2,kostka[0][1][1].p_l)&&consist(0,2,2,kostka[1][1][2].p_b)))
    {
	u();
	three_corners();
	three_corners();
	u();
	three_corners();
	three_corners();
	U();
	U();
	three_corners();
	three_corners();
	U();
	
    }
//wlasciwe narozniki we wlasciwych naroznikach (dol)
    all_F();
    all_F();
    while (!(consist(2,2,0,kostka[1][1][0].p_f)&&consist(2,2,0,kostka[2][1][1].p_r)))
	U();
    while (!(consist(0,2,0,kostka[0][1][1].p_l)&&consist(0,2,0,kostka[1][1][0].p_f)))
	three_corners();
    if (!(consist(0,2,2,kostka[0][1][1].p_l)&&consist(0,2,2,kostka[1][1][2].p_b)))
    {
	u();
	three_corners();
	three_corners();
	u();
	three_corners();
	three_corners();
	U();
	U();
	three_corners();
	three_corners();
	U();
	
    }
    all_F();
    all_F();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    U();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    u();
    all_f();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    U();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    u();
    all_f();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    U();
    while (kostka[0][2][2].p_u!=kostka[1][2][1].p_u)
	rotate_corners();
    u();
    all_f();
    all_f();
    while (kostka[0][0][0].p_d!=kostka[1][0][1].p_d)
    {
	all_U();
	all_U();
	left_right();
	all_U();
	all_U();
    }
    
    int tmp=0;
    for (i=0;i<4;)
    {
	if (consist(1,2,0,kostka[1][2][1].p_u))
	{
	    i++;
	    U();
	    continue;
	}
	if (consist(1,0,0,kostka[1][2][1].p_u))
	{
	    i++;
	    edges();
	    U();
	    continue;
	}
	if (consist(2,1,0,kostka[1][2][1].p_u))
	{
	    i++;
	    edges();
	    edges();
	    U();
	    continue;
	}
	all_u();
	U();
	tmp++;
    }
    for (i=0;i<tmp;i++)
    {
	all_U();
	u();
    }
    
    for (i=0;i<4;i++)
    {
	edges();
	edges();
	all_U();
    }
    for (i=0;i<4;i++)
    {
	while((!consist(1,0,0,kostka[0][2][0].p_f))||(!consist(1,0,0,kostka[1][2][1].p_u)))
	    D();
	edges();
	all_U();
    }
    while(kostka[0][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    
    for (i=0;i<4;i++)
    {
	if (kostka[1][2][2].p_u!=kostka[1][2][1].p_u)
	    flip_edges();
	U();
    }
    for (i=0;i<16;i++)
    {
	if (kostka[1][0][0].p_f==kostka[0][2][0].p_f&&kostka[1][0][0].p_d==kostka[1][2][1].p_u)
	{
	    edges();
	}
	if (kostka[1][2][0].p_f!=kostka[0][2][0].p_f)
	{
	    edges();
	    edges();
	}
	u();
    }
    //srodkowe krawedzie
    int j,k;
    j=0;
    k=0;
    //najpierw dolne krawedzie wywalamy na dol (nie ma znaczenia jak)
    for (i=0;i<4;i++)
    {
	if (consist(1,0,0,kostka[1][0][1].p_d))
	{
	    D();
	    k++;
	    continue;
	}
	while(!consist(0,1,0,kostka[1][0][1].p_d))
	{
	    D();
	    k++;
	    all_d();
	    j++;
	}
	all_f();
	edges();
	edges();
	all_F();
	D();
	k++;
    }
    for(;j>0;j--)
	all_D();
    for(;k>0;k--)
	d();
    //teraz srodkowe krawedzie wywalamy na dol tak by kolor lewej(prawej) scianki kostki byl dolem
    j = kostka[0][1][1].p_l;
    k = kostka[2][1][1].p_r;
    int l=0,m=0;
    int n=0;
    for (i=0;i<4;i++)
    {
	n=0;
	while(n<4&&(!consist(0,1,0,j))&&(!consist(0,1,0,k))||consist(0,1,0,kostka[1][0][1].p_d))
	{
	    n++;
	    all_D();
	    l++;
	}
	if (n==4)
	    continue;
	while(!consist(1,0,0,kostka[1][0][1].p_d))
	{
	    D();
	    m++;
	}
	if (kostka[0][1][0].p_l==j||kostka[0][1][0].p_l==k)
	{
	    all_f();
	    edges();
	    edges();
	    all_F();
	}
	else
	{
	    all_D();
	    d();
	    all_f();
	    edges();
	    all_F();
	    D();
	    all_d();
	}
    }
    for(;m>0;m--)
	d();
    for (;l>0;l--)
	all_d();
    //a teraz wstawiamy z dolu scianki do gory
    while(kostka[1][0][0].p_d!=kostka[2][1][1].p_r||kostka[1][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    all_f();
    edges();
    all_F();
    while(kostka[1][0][0].p_d!=kostka[0][1][1].p_l||kostka[1][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    all_f();
    edges();
    all_F();
    all_D();
    all_D();
    while(kostka[1][0][0].p_d!=kostka[2][1][1].p_r||kostka[1][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    all_f();
    edges();
    all_F();
    while(kostka[1][0][0].p_d!=kostka[0][1][1].p_l||kostka[1][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    all_f();
    edges();
    all_F();
    while(kostka[0][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    all_D();
    all_D();
    while(kostka[0][0][0].p_f!=kostka[1][1][0].p_f)
	D();
    //czas zajac sie dolnymi krawedziami
    for (i=0;i<4;i++)
    {
	if (kostka[1][0][0].p_d!=kostka[1][0][1].p_d)
	{
	    all_L();
	    all_L();
	    flip_edges();
	    all_L();
	    all_L();
	}
	D();
    }
    while(kostka[1][0][0].p_f!=kostka[1][1][0].p_f&&kostka[1][0][2].p_b!=kostka[1][1][2].p_b)
    {
	all_R();
	edges();
	all_r();
    }
    if (kostka[1][0][0].p_f==kostka[1][1][0].p_f)
    {
	while (kostka[1][0][2].p_b!=kostka[1][1][2].p_b)
	{
	    all_R();
	    all_f();
	    edges();
	    all_F();
	    all_r();
	}
    }
    else
    {
	while (kostka[1][0][0].p_f!=kostka[1][1][0].p_f)
	{
	    all_R();
	    all_F();
	    edges();
	    all_f();
	    all_r();
	}
    }
}
int main(int argc, char* argv[])
{

    char ch;    
    d_kostka k,l;
    m_kostka m;
    int d;
    scanf("%d%c",&d,&ch);
    assert(ch=='\n');
    assert(d>0&&d<5000);
    while(d--)
    {
        m.p_l=0;	//lewa strona
        m.p_r=0;	//prawa
        m.p_u=0;	//gora
        m.p_d=0;	//dol
        m.p_f=0;	//przod
        m.p_b=0;	//tyl
    
        int a,b,c;
        for (a=0;a<3;a++)
    	    for (b=0;b<3;b++)
    		for (c=0;c<3;c++)
    		    k.kostka[a][b][c]=m;
        k.read(stdin);
/*	printf("\n");
	k.show();*/
	scanf("%c",&ch);
	assert(ch=='\n');
	k.solve();
	printf("\n");
//	k.show();
    }
    return 0;
}
